module dmd.BoolExp;

import dmd.Expression;
import dmd.backend.elem;
import dmd.UnaExp;
import dmd.InterState;
import dmd.Type;
import dmd.Loc;
import dmd.Scope;
import dmd.IRState;
import dmd.TOK;

import dmd.backend.OPER;
import dmd.backend.Util;

class BoolExp : UnaExp
{
	this(Loc loc, Expression e, Type t)
	{
		super(loc, TOKtobool, BoolExp.sizeof, e);
		type = t;
	}

	override Expression semantic(Scope sc)
	{
		UnaExp.semantic(sc);
		e1 = resolveProperties(sc, e1);
		e1 = e1.checkToBoolean();
		type = Type.tboolean;
		return this;
	}

	override Expression optimize(int result)
	{
		assert(false);
	}

	override Expression interpret(InterState istate)
	{
		assert(false);
	}

	override int isBit()
	{
		return true;
	}

	override elem* toElem(IRState* irs)
	{
		elem* e1 = this.e1.toElem(irs);
		return el_una(OPbool,type.totym(),e1);
	}
}

